【整体二分】[POI2011]MET-Meteors

题目

题目描述
Byteotian Interstellar Union (BIU) has recently discovered a new planet in a nearby galaxy. The planet is unsuitable for colonisation due to strange meteor showers, which on the other hand make it an exceptionally interesting object of study.

The member states of BIU have already placed space stations close to the planet’s orbit. The stations’ goal is to take samples of the rocks flying by.

The BIU Commission has partitioned the orbit into mm sectors, numbered from 11 to mm, where the sectors 11 and mm are adjacent. In each sector there is a single space station, belonging to one of the nn member states.

Each state has declared a number of meteor samples it intends to gather before the mission ends. Your task is to determine, for each state, when it can stop taking samples, based on the meter shower predictions for the years to come.

给定一个环,每个节点有一个所属国家,k次事件,每次对[l,r]区间上的每个点点权加上一个值,求每个国家最早多少次操作之后所有点的点权和能达到一个值

输入格式
The first line of the standard input gives two integers, nn and mm (1\le n,m\le 300\ 0001≤n,m≤300 000), separated by a single space, that denote,respectively, the number of BIU member states and the number of sectors the orbit has been partitioned into.

In the second line there are mm integers o_io
i

(1\le o_i\le n1≤o
i

≤n),separated by single spaces, that denote the states owning stations in successive sectors.

In the third line there are nn integers p_ip
i

(1\le p_i\le 10^91≤p
i

≤10
9
),separated by single spaces, that denote the numbers of meteor samples that the successive states intend to gather.

In the fourth line there is a single integer kk (1\le k\le 300\ 0001≤k≤300 000) that denotes the number of meteor showers predictions. The following kk lines specify the (predicted) meteor showers chronologically. The ii-th of these lines holds three integers l_i,r_i,a_il
i

,r
i

,a
i

(separated by single spaces), which denote that a meteor shower is expected in sectors l_i,l_{i+1},…,r_il
i

,l
i+1

,…,r
i

(if l_i\le r_il
i

≤r
i

) or sectors l_i,l_{i+1},…,m,1,…,r_il
i

,l
i+1

,…,m,1,…,r
i

(if l_i>r_il
i

r
i

) , which should provide each station in those sectors with a_ia
i

meteor samples (1\le a_i\le 10^91≤a
i

≤10
9
).

输出格式
Your program should print nn lines on the standard output.

The ii-th of them should contain a single integer w_iw
i

, denoting the number of shower after which the stations belonging to the ii-th state are expected to gather at least p_ip
i

samples, or the word NIE (Polish for no) if that state is not expected to gather enough samples in the foreseeable future.

题意翻译
Byteotian Interstellar Union 有 n​n​ 个成员国。现在它发现了一颗新的星球,这颗星球的轨道被分为 m​m​ 份(第 m​m​ 份和第 1​1​ 份相邻),第 i​i​ 份上有第 a_i​a
i

​ 个国家的太空站。

这个星球经常会下陨石雨。BIU 已经预测了接下来 kk 场陨石雨的情况。

BIU 的第 ii 个成员国希望能够收集 p_ip
i

单位的陨石样本。你的任务是判断对于每个国家,它需要在第几次陨石雨之后,才能收集足够的陨石。

输入格式
第一行是两个数 n,mn,m。

第二行有 mm 个数,第 ii 个数 o_io
i

表示第 ii 段轨道上有第 o_io
i

个国家的太空站。

第三行有 nn 个数,第 ii 个数 p_ip
i

表示第 ii 个国家希望收集的陨石数量。

第四行有一个数 kk,表示 BIU 预测了接下来的 kk 场陨石雨。 接下来 kk 行,每行有三个数 l_i,r_i,a_il
i

,r
i

,a
i

,表示第 kk 场陨石雨的发生地点在从 l_il
i

顺时针到 r_ir
i

的区间中(如果 l_i\le r_il
i

≤r
i

,就是 l_i,l_i+1,\cdots,r_il
i

,l
i

+1,⋯,r
i

,否则就是 r_i,r_i+1,\cdots,m-1,m,1, 2, …, l_ir
i

,r
i

+1,⋯,m−1,m,1,2,…,l
i

),向区间中的每个太空站提供 a_ia
i

单位的陨石样本。

输出格式
输出 nn 行。第 ii 行的数 w_iw
i

表示第 ii个国家在第 w_iw
i

波陨石雨之后能够收集到足够的陨石样本。如果到第 kk 波结束后仍然收集不到,输出NIE。

数据范围
1\le n,m,k\le 3\cdot10^51≤n,m,k≤3⋅10
5

1\le p_i,a_i\le 10^91≤p
i

,a
i

≤10
9

输入输出样例
输入 #1复制
3 5
1 3 2 1 3
10 5 7
3
4 2 4
1 3 1
3 5 2
输出 #1复制
3
NIE
1

在洛谷,
享受Coding的欢乐

思路

这题思路是整体二分,就是把所有查询丢到队列里后二分,

mid=(L+R)/2把mid前可以完成任务的国家 丢到左边的队列,不能的丢到右边,如果达到边界 (L==R),就把队列里的询问答案赋值为LL,每次用树状数组修改和求前缀和就行;

代码

#include<bits/stdc++.h>
using namespace std;
#define N 300010
struct Per {int head,id;long long need;}per[N],per_[N<<1];
int n,m,k,L[N],R[N];long long A[N];int ans[N],nxt[N],to[N],idx;long long tmp[N<<1];
void add(int a,int b) {nxt[++idx]=per[a].head,to[idx]=b,per[a].head=idx;}
void change(int x,long long y) {while(x<=2*m) tmp[x]+=y,x+=x&-x;}
long long find(int x) {long long sum=0;while(x) sum+=tmp[x],x-=x&-x;return sum;}
void solve(int l,int r,int x,int y)
{
    if(l==r) {for(int i=x;i<=y;i++) ans[per[i].id]=l;return;}
    int mid=(l+r)>>1,tl=0,tr=n;
    for(int i=l;i<=mid;i++) change(L[i],A[i]),change(R[i]+1,-A[i]);
    for(int i=x;i<=y;i++)
    {
        long long tmp1=0;
        for(int j=per[i].head;j&&tmp1<=per[i].need;j=nxt[j])
            tmp1+=find(to[j]+m)+find(to[j]);
        if(tmp1>=per[i].need) per_[++tl]=per[i];
        else per_[++tr]=per[i],per_[tr].need-=tmp1;
    }
    for(int i=l;i<=mid;i++) change(L[i],-A[i]),change(R[i]+1,A[i]);
    for(int i=1;i<=tl;i++) per[x+i-1]=per_[i];
    for(int i=n+1;i<=tr;i++) per[x+tl+i-n-1]=per_[i];
    solve(l,mid,x,x+tl-1),solve(mid+1,r,y-tr+n+1,y);
}
int main()
{
    scanf("%d%d",&n,&m);
    for(int i=1,a;i<=m;i++) scanf("%d",&a),add(a,i);
    for(int i=1;i<=n;i++) scanf("%lld",&per[i].need),per[i].id=i;
    scanf("%d",&k);for(int i=1;i<=k;i++) scanf("%d%d%lld",&L[i],&R[i],&A[i]);
    for(int i=1;i<=k;i++) if(R[i]<L[i]) R[i]+=m; solve(1,k+1,1,n);
    for(int i=1;i<=n;i++) (ans[i]==k+1)?printf("NIE\n"):printf("%d\n",ans[i]);
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值